var PARAMS = {
	VENDORS_SERVER: "http://vendors.i-free.ru/test/chess",
//	VENDORS_SERVER: "http://m.i-free.com/m",
	GAME_NAME: "reversi",
//	GAME_NAME: "checkers",
	INVITE: "invite",
	PLAYERS: "players",
	DUELS: "duels",
	CHECK_LOGIN: "checkLogin",
	INVITE_CONTROL: "invite-control",
	MOVE: "duelcontrol",
	vkontakte_login: "vklogin",
	facebook_login: "fblogin",
	PAGE_AUTHORIZATION: "index.html",
	PAGE_MENU: "menu.html",
	PAGE_GAME: "game.html"
};

window.$ = function(id) {
	return document.getElementById(id);
};

window.$$ = function(node, tagName) {
	return node.getElementsByTagName(tagName);
};

var utils = {
	_extraNames :["hasOwnProperty", "valueOf", "isPrototypeOf", "propertyIsEnumerable", "toLocaleString", "toString", "constructor"],
	_mixin : function(target, source) {
		var extraLen = utils._extraNames.length;
		var empty = {};
		var name, s, i;
		for (name in source) {
			s = source[name];
			if (!(name in target) || (target[name] !== s && (!(name in empty) || empty[name] !== s))) {
				target[name] = s;
			}
		}
		if (extraLen && source) {
			for (i = 0; i < extraLen; ++i) {
				name = utils._extraNames[i];
				s = source[name];
				if (!(name in target) || (target[name] !== s && (!(name in empty) || empty[name] !== s))) {
					target[name] = s;
				}
			}
		}
		return target;
	},
	mixin :function(obj, props) {
		if (!obj) {
			obj = {};
		}
		for (var i = 1, l = arguments.length; i < l; i++) {
			utils._mixin(obj, arguments[i]);
		}
		return obj;
	},
	_getParts : function(arr, obj, cb) {
		return [
			(typeof arr == "string") ? arr.split("") : arr,
			obj || this,
			(typeof cb == "string") ? new Function("item", "index", "array", cb) : cb
		];
	},
	forEach: function(arr, callback, thisObject) {
		if (!arr || !arr.length) {
			return;
		}
		var _p = utils._getParts(arr, thisObject, callback);
		arr = _p[0];
		for (var i = 0,l = arr.length; i < l; ++i) {
			_p[2].call(_p[1], arr[i], i, arr);
		}
	},
	status: {
		isOk: function(res) {
			return (res.Status == "ok");
		},
		isError: function(res) {
			return (res.Status == "error");
		},
		isCompleted: function(res) {
			return (res.Status == "complete");
		}
	},
	html: {
		removeNode: function(node) {
			var nodes = (node.constructor == Array) ? node : [node];
			for (var i = 0, l = nodes.length; i < l; ++i) {
				var n = nodes[i];
				n.parentNode && n.parentNode.removeChild(n);
			}
		},
		setSrcToImg: function(node, src) {
			utils.addClass(node, "hidden");
			var onLoad = function() {
				utils.removeClass(node, "hidden");
				disconnect();
			};
			var onError = function() {
				disconnect();
			};
			var disconnect = function() {
				node.removeEventListener("load", onLoad, false);
				node.removeEventListener("error", onError, false);
			};
			node.addEventListener("load", onLoad, false);
			node.addEventListener("error", onError, false);
			node.setAttribute("src", src);
		}
	},
	login: function(data) {
		if (data.Status == "error") {
			utils.redirectToPage(PARAMS.PAGE_AUTHORIZATION);
		}
	},
	paramsToQuery: function(attrs) {
		var query = [];
		for (var name in attrs) {
			var value = attrs[name];
			query.push(name + '=' + (value || "").toString());
		}
		return (query.join("&"));
	},
	queryToParams: function(query) {
		query = query.replace(/[?]/g, "");
		var params = {};
		var queryArray = query.split("&");
		for (var i = 0, l = queryArray.length; i < l; ++i) {
			var str = queryArray[i];
			var strArr = str.split("=");
			if (strArr.length == 2) {
				params[strArr[0]] = strArr[1];
			}
		}
		return (params);
	},
	parseUrl: function(url) {
		var index = url.indexOf("?");
		index = (index > 0) ? index : url.length;
		var result = {};
		result.url = url.substring(0, index);
		result.params = utils.queryToParams(url.substring(index, url.length));
		return (result);
	},
	redirectToUrl: function(url) {
		document.location.href = url;
	},
	redirectToPage: function(pageName, params) {
//		return true;
		debugger;
		var location = document.location.href;
		if (location.indexOf(pageName) < 0) {
			location = location.substring(0, location.lastIndexOf('/') + 1);
			var url = utils.addParamsToUrl(location + pageName, params);
			utils.redirectToUrl(url);
		}
	},
	reloadPage: function() {
		document.location.reload();
	},
	//FIXME: remove this function from here.
	setUserInfoToDom: function(user) {
		var userNameNode = document.getElementById("user_name");
		userNameNode.innerHTML = user.name;
		var userPhotoNode = document.getElementById("user_photo");
		utils.html.setSrcToImg(userPhotoNode, user.avatar);
	},
	addParamsToUrl: function(url, attrs) {
		var params = utils.paramsToQuery(attrs || {});
		return (url + (!!params ? ("?" + params) : ""));
	},
	generateUrl: function() {
		var result = [];
		for (var i = 0; i < arguments.length; ++i) {
			result.push(arguments[i]);
		}
		return (result.join('/'));
	},
	create: function(tagName, attrs, parentNode) {
		var node = document.createElement(tagName);
		attrs = attrs || {};
		for (var name in attrs) {
			var value = attrs[name];
			if (name == "innerHTML") {
				node.innerHTML = value;
				continue;
			}
			if (name == "className") {
				utils.addClass(node, value);
				continue;
			}
			node.setAttribute(name, value);
		}
		if (parentNode) {
			parentNode.appendChild(node);
		}
		return (node);
	},
	removeClass: function (node, className) {
		var removedClass = node.className;
		var pattern = new RegExp("(^| )" + className + "( |$)");
		removedClass = removedClass.replace(pattern, "$1");
		removedClass = removedClass.replace(/ $/, "");
		node.className = removedClass;
		return (true);
	},
	addClass: function(node, className) {
		if (!utils.hasClass(node, className)) {
			if (node.className == "") {
				node.className = className;
			}
			else {
				node.className += " " + className;
			}
		}
		return (true);
	},
	hasClass: function(node, className) {
		var pattern = new RegExp("(^| )" + className + "( |$)");
		return (!!node.className.match(pattern));
	},
	checkResponse: function(res) {
		if (utils.status.isError(res)) {
			utils.showAlert(res.ErrorMsg);
		}
	},
	includes: function (arr, el) {
		return ('|' + arr.join('|') + '|').indexOf('|' + el + '|') > -1;
	},
	showAlert: function(message, time) {
		var body = document.body;
		var shadowContainer = utils.create("div", {
			className: "shadowContainer"
		}, body);
		var y = window.scrollY;
		var dy = (navigator.userAgent.match(/iPhone/i)) ? 65 : 0;
		shadowContainer.style.top = y + "px";
		shadowContainer.style.bottom = -y - dy + "px";
		var alertContainer = utils.create("div", {
			className: "alertContainer"
		}, body);
		alertContainer.style.top = y + "px";
		alertContainer.style.bottom = -y - dy + "px";
		var alertWrapper = utils.create("div", {
			className: "alertWrapper"
		}, alertContainer);
		var messageNode = utils.create("div", {
			className: "alertMessage",
			innerHTML: "<span class='message'>" + message + "</span>"
		}, alertWrapper);
		utils.addClass(document.body, "alertError");
		setTimeout(function() {
			utils.removeClass(document.body, "alertError");
			utils.forEach([shadowContainer, alertContainer, alertWrapper, messageNode], function(node) {
				utils.html.removeNode(node);
			});
		}, time || 2000);
	},
	mobileClick: function(node, callback, timer) {
		node && utils.addClass(node, "clicked");
		setTimeout(function() {
			node && utils.removeClass(node, "clicked");
			callback && callback();
		}, timer || 300);
	},
	getLocation: function() {
		var n = navigator;
		var lan = ((n.language || n.userLanguage || n.systemLanguage || n.browserLanguage).toLowerCase());
		var tags = lan.split('-');
		var lang = tags[0] || tags[1] || "en";
//		var lang = "ru";
		return (utils.includes(["ru", "en"], lang) ? lang : "en");
	},
	JSONP : (function(scope) {
		var scope = scope || this;
		var id = 0;

		return function (uri, params, callback, redirect) {
			var src = "__JSONP__" + id++;

			var pUrl = utils.parseUrl(uri);
			var url = utils.addParamsToUrl(pUrl.url, utils.mixin(params || {}, {
				jsoncallback: src,
				lang: utils.getLocation()
			}, pUrl.params));

			var script = utils.create("script", {
				src: url
			}, document.body);

			scope[src] = function() {
				if (scope[src]) {
					delete scope[src]
				}
				utils.html.removeNode(script);
				if (redirect !== false) {
					utils.login.apply(this, arguments);
				}
				callback && callback.apply(this, arguments);
			};
		}
	})()
};

var loader = {
	_loaders: [],
	addOnLoad: function(foo) {
		loader._loaders.push(foo);
	},
	windowLoaded: function() {
		var loaders = loader._loaders;
		for (var i = 0, l = loaders.length; i < l; ++i) {
			var foo = loaders[i];
			foo.call(this);
		}
	}
};

var translater = {
	translate: function() {
		var local = utils.getLocation();
		var script = utils.create("script", {
			src: "./js/nls/" + local + ".js"
		}, document.body);
		script.addEventListener("load", function() {
			utils.forEach(document.getElementsByClassName("translateText"), function(node) {
				var str = node.innerHTML;
				var req = /#\{(\w+)\}/
				if (req.test(str)) {
					var replaceText = req.exec(str)[1].toLowerCase();
					var text = LOCALIZATION[replaceText];
					node.innerHTML = text;
				}
			});
			utils.removeClass(document.body, "translate");
		});
	}
};

window.addEventListener("load", translater.translate, false);
window.addEventListener("load", loader.windowLoaded, false);

// Hide addres bar for mobile
function hideAddressBar() {
	// to ensure enough height for scrollTo to work
//	document.body.style.minHeight = "1000px";
	setTimeout(function() {
		window.scrollTo(0, 1);
	}, 100);
	setTimeout(function() {
		window.scrollTo(0, 1);
	}, 400);
	setTimeout(function() {
		window.scrollTo(0, 1);
		// re-define the min-height with the actual height
//		document.body.style.minHeight = (window.innerHeight || document.documentElement.clientHeight) + "px";
	}, 1000);
}

loader.addOnLoad(function() {
	hideAddressBar();
	window.addEventListener("orientationchange", hideAddressBar);
//	window.addEventListener("resize", hideAddressBar);
});